#define _BSD_SOURCE 1
#define PACKETSIZE 65536 /* No, I don't expect to get that big */
#define FILTERSIZE 8192
#define TMPBUFSIZE 1024
#define FQDNMAX 8192
#define TIMEOUT 3000 /* In milliseconds */
#define PACKETWAIT 300 /* In milliseconds */
#define DEFAULTTCPPORT 80
#define LSROVERHEAD 3
#define TYPE_TO      1
#define TYPE_THROUGH 2
#define TYPE_BOTH    3

#include <pcap.h>
#include <dnet.h>

struct packetInfo {
  uint16_t destPort;
  uint16_t sourcePort;
  uint32_t ipHops[11]; /*Can put 9 source route hops, source, and dest */
  int currentHop;       /*The addr we claim it just came from*/ 
  int myHop;            /*Which IP "I" am */
  int hopCount;         /*Total # of IPs in ipHops array*/
  uint32_t sequenceNum;
  int type;             /*Type of scan, TO, THROUGH, or both*/
  int silentIP;        /*Set if we're not inserting our real IP anywhere*/
};

int fillBufRandomly(void *, int);
int getLinkSize(pcap_t *);
pcap_t * initListen(struct packetInfo *, struct addr *);
int getResponse(pcap_t *, struct packetInfo *);
int checkPacket(uint8_t *, struct packetInfo *);
int fillIPHeader(uint8_t *, struct packetInfo *);
int fillIPOptLSR(uint8_t *, struct packetInfo *);
int fillTCPHeader(uint8_t *, struct packetInfo *);
int sendLSR(struct packetInfo *);
