#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "lsrscan.h"

int fillBufRandomly(void *buf, int bytes) {
  static int seeded = 0;
  int randomFile;
  int bytesRemaining;
  struct timeval tv;
  long int tempRand;
  ssize_t bytesRead;

  bytesRemaining = bytes;

  if(bytes < 1) return(-1);

  if((randomFile = open("/dev/urandom", O_RDONLY)) < 0) {
    if((randomFile = open("/dev/random", O_RDONLY)) < 0) {
      if(seeded == 0) {
	gettimeofday(&tv, NULL);
	srand48(tv.tv_sec ^ tv.tv_usec);
	seeded = 1;
      }
      while(bytesRemaining > 0) {
	tempRand = lrand48();
	if (bytesRemaining < sizeof(long int)) {
	  memcpy(buf, &tempRand, bytesRemaining);
	  bytesRemaining = 0;
	} else {
	  memcpy(buf, &tempRand, sizeof(long int));
	  bytesRemaining -= sizeof(long int);
	  buf += sizeof(long int);
	}
      }
      return(0);
    } 
  }
    
  while(bytesRemaining > 0) {
    if((bytesRead = read(randomFile, buf, bytesRemaining)) <= 0) {
      return(-1);
    }
    bytesRemaining -= bytesRead;
    buf+= bytesRead;
  }
  return(0);
}

